
// main 1 second routine, invoked from main() on AVR, from 500/1000ms interrupt on ESP
#include "onewire.h"

extern	void		prepare_time_to_display(void);
extern	void		prepare_hex_byte_to_lcd1(uint8_t);
extern	void		address_dallas(uint8_t);
extern	void		decode_dallas(uint8_t);
extern	void		display_3rd_lcd_line(void);
extern	uint16_t	Akas_lookup(uint16_t);

#if defined(__ets__)
//					    Serial.print((char *)&buffer_tx[0]);
extern	bool		IP_connected;
extern	TcpClient*	last_TcpClient;
extern	boolean		temp_100s_valid[4];;
extern	OneWire		OneWire_bus;
#endif

#if defined(__AVR__)
#include <avr/io.h>

extern	uint8_t		temp_100s_valid;

extern	uint8_t		ow_byte_wr(uint8_t);
#endif

extern	void		display_3rd_lcd_line(void);

extern	uint8_t		lcd_offset;

extern	uint8_t		STS_byte3;
extern	uint8_t		STS_byte2;
extern	uint8_t		STS_byte1;

extern	uint8_t		lcd_pointer;
extern	uint8_t		i, j;
#if defined(__AVR__)
extern	volatile uint8_t	num_of_sensors;
extern	volatile uint8_t	buffer_tx[120];
extern	volatile uint8_t	tx_pointer;
extern	volatile uint8_t	lcd_time[10];
#endif
#if defined(__ets__)
extern	uint8_t		num_of_sensors;
extern	uint8_t		buffer_tx[120];
extern	uint8_t		lcd_time[10];

extern	float		STS_Temperature;
extern 	boolean		STS_Ready;

#endif

extern	volatile uint8_t	error_code;

extern	uint8_t		temp_units[4];
extern	uint16_t	temp_parts[4];
extern	uint8_t		temp_sign[4];
extern	uint16_t	temp_100s[4];

extern	uint8_t		temp_units_t;
extern	uint16_t	temp_parts_t;
extern	uint8_t		temp_sign_t;
extern	uint16_t	temp_100s_t;

extern	uint32_t	temp_100s_t2;
extern	uint32_t	temp_100s_t2_min;
extern	uint32_t	temp_100s_t2_max;

extern	uint16_t	temp_1_filter_10sec_100s[10];
extern	uint8_t		temp_1_filter_10sec_pointer;
extern	uint16_t	temp_1_filtered_10sec_100s;
extern	uint32_t	temp_1_filtered_10sec_100s_32;

extern	uint16_t	temp_percentage_100s_t;

extern	volatile uint8_t	flagi;
extern	volatile uint8_t	flagi2;
extern	volatile uint8_t 	flagi3;

extern	uint8_t		sensor_addreses[4][8];

extern	char		lcd_line1[17];
extern	uint8_t		virt_lcd_line2[49];

extern	uint8_t		alarm_type;

extern	volatile uint8_t	auto_pwm_downcount_timer_minute;
extern	volatile uint8_t	auto_pwm_downcount_timer_second;

#if defined(INCLUDE_RTC)
extern	volatile uint8_t	second;
#endif

extern	volatile uint8_t	pwm_output;
extern	volatile uint8_t	pwm_output_idx;
extern	const uint8_t	PWM_table[PWM_TABLE_MAX];

extern	uint16_t	temp_2_filter_10sec_100s[10];
extern	uint8_t		temp_2_filter_10sec_pointer;
extern	uint32_t	temp_2_filtered_10sec_100s_32;
extern	uint16_t	temp_2_filtered_10sec_100s;

extern	uint16_t	temp_delta_base_100s[4];
extern	uint16_t	temp_100s_d;
extern	uint8_t		temp_sign_d;

extern	uint16_t	temp_100s_delta[4];

#if defined(__AVR__)
extern	uint8_t		temp_100s_delta_sign;
#endif
#if defined(__ets__)
extern	bool		temp_100s_delta_sign[4];
#endif

extern	uint8_t		temperature_labels[4][8];

/* --------------------------------------------------- */

void do_1s_stuff(void);

/* --------------------------------------------------- */
