#
#include "do_config.h"
#
#if defined(__AVR__)
    #include <avr/wdt.h>
    #include <avr/eeprom.h>
    #include <avr/sleep.h>
    #include <util/delay.h>
#endif

#if defined(__ets__)
    #include <Libraries/LiquidCrystal/LiquidCrystal_I2C.h>
    #include "lcd.h"
#endif

void do_config(void) 
{ /* IN CONFIG */
uint8_t	z, i, j;

#if defined(__AVR__)
		lcd_gotoxy(0,0); 
		lcd_puts("Tryb konfigur.");
		lcd_gotoxy(0,1);
		lcd_puts("Liczba czujn.:");
		lcd_putc(num_of_sensors + '0');
		_delay_ms(2000);
		for (z = 0; z < 4; z++) {
		    lcd_gotoxy(0,0);
		    switch (z) {
			case 0:
				lcd_putc('T');
				for (i = 0; i < 7; i++) {
				    lcd_putc(temperature_labels[0][i]);
							}
				break;
			case 1:
				lcd_putc('T');
				for (i = 0; i < 7; i++) {
				    lcd_putc(temperature_labels[1][i]);
							}
				break;
			case 2:
				lcd_putc(' ');
				for (i = 0; i < 7; i++) {
				    lcd_putc(temperature_labels[2][i]);
							}
				break;
			case 3:
				lcd_putc(' ');
				for (i = 0; i < 7; i++) {
				    lcd_putc(temperature_labels[3][i]);
							}
				} //switch (z)
		    lcd_puts(":        ");
// KEY 1 on PRODUCTION / NANO, KEY 2 on PRODUCTION by krzyski
#if defined(KEY_1_PIN)
		    while ((soft_keys & SOFT_KEY_1_MASK) == 0) {
#else
		    while ((soft_keys & SOFT_KEY_2_MASK) == 0) {
#endif
		    /* while not keypressed & ROM OK */
			sleep_mode();
			ow_reset();
			ow_byte_wr(OW_READ_ROM);
			for (i = 0; i < 8; i++) {
			    scratchpad_table[z][i] = ow_byte_rd();
						}
			j = crc8(&scratchpad_table[z][0],8);
			lcd_gotoxy(9,0);
			if ( j == 0 ) { lcd_puts("OK"); }
			else	  { lcd_puts("--"); }
			lcd_gotoxy(0,1);
			lcd_puts("Numer  czujn.:");
			lcd_putc(z + '1');
						    } /* while */
		    /* store ROM address in EEPROM */
			for (i = 0; i < 8; i++) {
			    eeprom_write_byte(&sensor_addreses_eeprom[z][i], scratchpad_table[z][i]);
						}
		    /* wait key released */
// KEY 1 on PRODUCTION / NANO, KEY 2 on PRODUCTION by krzyski
#if defined(KEY_1_PIN)
		    while ((soft_keys & SOFT_KEY_1_MASK) != 0) { 
#else
		    while ((soft_keys & SOFT_KEY_2_MASK) != 0) { 
#endif
			sleep_mode();
			if ((flagi & MS100_FLAG) != 0) { deciseconds++; 
							 flagi &= ~ MS100_FLAG;
							 if (deciseconds > 60) {
							    for (i = 0; i < 4; i++) {
								for (j = 0; j < 8; j++) {
								    eeprom_write_byte(&sensor_addreses_eeprom[i][j], 0xFF);
										        }
										    }
							    eeprom_write_byte(&num_of_sensors_eeprom, 0);
							    eeprom_write_byte(&lcd_flags_in_eeprom, LCD_DEFAULT_FLAGS);
							    flagi |= CONFIG_CLEARED_FLAG;
							    break;
										}
							}
								} /* while */
		/* ! IN_CONFIG but z =0-3 */
		    if ((flagi & CONFIG_CLEARED_FLAG) == 0) { eeprom_write_byte(&num_of_sensors_eeprom, (z + 1)); }
		    else { break; }

			 } /* FOR IN_CONFIG */
		lcd_clrscr();
		lcd_gotoxy(0,0);
		lcd_puts("Konfiguracja");
		lcd_gotoxy(0,1);
		if (eeprom_read_byte(&num_of_sensors_eeprom) != 0) { lcd_puts("Zapisana"); }
		    else					   { lcd_puts("Skasowana"); }
		wdt_enable(WDTO_2S);  /* reset after 2s, on 328P need MCUSR = 0 & disable_wdt in .init3 */
		while (1 == 1) { } /* dummy loop */

		return;
#endif
	     } /* IN CONFIG */
