#ifndef IOINIT_H
#define IOINIT_H

#include <inttypes.h>
#include "defines.h"

#if defined(__AVR__)
    #include <util/setbaud.h>
#endif

extern const uint16_t Timer1_prescale;
extern const uint16_t half_period;

#if defined(__ets__)
    #include <SmingCore/SmingCore.h>
    #include <SmingCore/Platform/WDT.h>
    #include <Libraries/OneWire/OneWire.h>

#if defined(NODEMCU_HARDWARE_TIMER)
    #include <SmingCore/HardwareTimer.h>
    extern Hardware_Timer Timer_1;
#else
    extern Timer 	Timer_1;
#endif
    extern Timer 	Timer_2;

    extern Timer 	Timer_500ms;
    extern void Timer_500ms_ISR(void);

    extern void Timer_1_ISR(void);
    extern void Timer_2_ISR(void);

    extern OneWire 	OneWire_bus;
    extern WDTClass 	watchdog;
#endif

extern void ioinit(void);

#endif