/* keyboard filtering - platform independent */
/* ------------------------------------------*/
#include "defines.h"

#if defined(__AVR__)
    #include <avr/pgmspace.h>
    #include <avr/eeprom.h>
#endif

#include "keyboard_filter.h"

void keyboard_filter(void)

{

#if (defined(KEY_1_PIN) || defined(KEY_1_BIT))
    key_1_filter <<= 1;
    key_1_filter &= 0x0F;
    #if defined(__AVR__)
		if ((KEY_1_PINR & _BV(KEY_1_BIT)) == 0) { key_1_filter |= 1; }
    #endif
    #if defined(__ets__)
		if (digitalRead(KEY_1_PIN) == 0) { key_1_filter |= 1; }
    #endif
    if (ones_count8(key_1_filter, 4) > 1) { soft_keys |= SOFT_KEY_1_MASK; }
	else 				  { soft_keys &= ~SOFT_KEY_1_MASK; }
#endif

#if (defined(KEY_2_PIN) || defined(KEY_2_BIT))
    key_2_filter <<= 1;
    key_2_filter &= 0x0F;
    #if defined(__AVR__)
		if ((KEY_2_PINR & _BV(KEY_2_BIT)) == 0) { key_2_filter |= 1; }
    #endif
    #if defined(__ets__)
	    if (digitalRead(KEY_2_PIN) == 0) { key_2_filter |= 1; }
    #endif
    if (ones_count8(key_2_filter, 4) > 1) { soft_keys |= SOFT_KEY_2_MASK; }
	else 				  { soft_keys &= ~SOFT_KEY_2_MASK; }
#endif

#if (defined(KEY_3_PIN) || defined(KEY_3_BIT))
    key_3_filter <<= 1;
    key_3_filter &= 0x0F;
    #if defined(__AVR__)
		if ((KEY_3_PINR & _BV(KEY_3_BIT)) == 0) { key_3_filter |= 1; }
    #endif
    #if defined(__ets__)
		if (digitalRead(KEY_3_PIN) == 0) { key_3_filter |= 1; }
    #endif
    if (ones_count8(key_3_filter, 4) > 1) { soft_keys |= SOFT_KEY_3_MASK; }
	else 				  { soft_keys &= ~SOFT_KEY_3_MASK; }
#endif

#if (defined(KEY_4_PIN) || defined(KEY_4_BIT))
    key_4_filter <<= 1;
    key_4_filter &= 0x0F;
    #if defined(__AVR__)
		if ((KEY_4_PINR & _BV(KEY_4_BIT)) == 0) { key_4_filter |= 1; }
    #endif
    #if defined(__ets__)
		if (digitalRead(KEY_4_PIN) == 0) { key_4_filter |= 1; }
    #endif
    if (ones_count8(key_4_filter, 4) > 1) { soft_keys |= SOFT_KEY_4_MASK; }
	else				  { soft_keys &= ~SOFT_KEY_4_MASK; }
#endif

#if !(defined PWM_TIMER || defined(I2C_IO))
    #if (defined(KEY_5_PIN) || defined(KEY_5_BIT))
	key_5_filter <<= 1;
	key_5_filter &= 0x0F;
        #if defined(__AVR__)
			if ((KEY_5_PINR & _BV(KEY_5_BIT)) == 0) { key_5_filter |= 1; }
        #endif
        #if defined(__ets__)
			if (digitalRead(KEY_5_PIN) == 0) { key_5_filter |= 1; }
	#endif
        if (ones_count8(key_5_filter, 4) > 1) { soft_keys |= SOFT_KEY_5_MASK; }
		else 				  { soft_keys &= ~SOFT_KEY_5_MASK; }
    #endif
#endif

#if (defined(__AVR_ATmega328P__) || defined(__AVR_ATmega168P__) || defined(__ets__))
    #if (defined(KEY_6_PIN) || defined(KEY_6_BIT))
        key_6_filter <<= 1;
        key_6_filter &= 0x0F;
        #if defined(__AVR__)
		if ((KEY_6_PINR & _BV(KEY_6_BIT)) == 0) { key_6_filter |= 1; }
        #endif
	#if defined(__ets__)
		if (digitalRead(KEY_6_PIN) == 0) { key_6_filter |= 1; }
        #endif
        if (ones_count8(key_6_filter, 4) > 1) { soft_keys |= SOFT_KEY_6_MASK; }
	else 				      { soft_keys &= ~SOFT_KEY_6_MASK; }
    #endif
#endif
	
#if (defined(__AVR_ATmega328P__) || defined(__AVR_ATmega168P__))
    #if (defined(ENCODER_PLUS_PIN) || defined(ENCODER_PLUS_BIT))
        encoder_plus_filter <<= 1;
	encoder_plus_filter &= 0x0F;
        #if defined(__AVR__)
    		if ((ENCODER_PLUS_PINR & _BV(ENCODER_PLUS_BIT)) == 0) { encoder_plus_filter |= 1; }
        #endif
        #if defined(__ets__)
    		if (digitalRead(ENCODER_PLUS_PIN) == 0) { encoder_plus_filter |= 1; }
        #endif
        if (ones_count8(encoder_plus_filter, 4) > 1) { soft_keys2 |= SOFT_ENCODER_PLUS_MASK; }
    	else 				 	     { soft_keys2 &= ~SOFT_ENCODER_PLUS_MASK; }
    #endif
#endif

#if (defined(__AVR_ATmega328P__) || defined(__AVR_ATmega168P__))
    #if (defined(ENCODER_MINUS_PIN) || defined(ENCODER_MINUS_BIT))
        encoder_minus_filter <<= 1;
        encoder_minus_filter &= 0x0F;
        #if defined(__AVR__)
    		if ((ENCODER_MINUS_PINR & _BV(ENCODER_MINUS_BIT)) == 0) { encoder_minus_filter |= 1; }
        #endif
        #if defined(__ets__)
    		if (digitalRead(ENCODER_MINUS_PIN) == 0) { encoder_minus_filter |= 1; }
        #endif
        if (ones_count8(encoder_minus_filter, 4) > 1) { soft_keys2 |= SOFT_ENCODER_MINUS_MASK; }
    	else 				 	  { soft_keys2 &= ~SOFT_ENCODER_MINUS_MASK; }
    #endif
#endif
	
#if (defined(__AVR_ATmega328P__) || defined(__AVR_ATmega168P__) || defined(__ets__))
    #if (defined(ENCODER_SWITCH_PIN) || defined(ENCODER_SWITCH_BIT))
        encoder_switch_filter <<= 1;
        encoder_switch_filter &= 0x0F;
        #if defined(__AVR__)
		if ((ENCODER_SWITCH_PINR & _BV(ENCODER_SWITCH_BIT)) == 0) { encoder_switch_filter |= 1; }
        #endif
        #if defined(__ets__)
		if (digitalRead(ENCODER_SWITCH_PIN) == 0) { encoder_switch_filter |= 1; }
	#endif
        if (ones_count8(encoder_switch_filter, 4) > 1) { soft_keys3 |= SOFT_ENCODER_SWITCH_MASK; }
	else 				 	   { soft_keys3 &= ~SOFT_ENCODER_SWITCH_MASK; }
    #endif
#endif
	
/*--------------------------------------------------------------------*/
/* Actions based on (soft) KEYS state/change 			      */
/*--------------------------------------------------------------------*/
    /* press KEY_3 - 1st LCD line - column */
	  if (((soft_keys & SOFT_KEY_3_MASK) != 0) && ((soft_keys & SOFT_KEY_3_OLD_MASK) == 0)) { 
							flagi2 ^= COLUMN_IS_DELTA_FLAG;
							if ((flagi2 & COLUMN_IS_DELTA_FLAG) != 0) {
								 	// set BASE depending filter enabled / disabled.
								 	if (flagi3 & TEMP_1_FILTER_ENABLED)  
								 		{ temp_delta_base_100s[0] = temp_1_filtered_10sec_100s; }
								 	else	{ temp_delta_base_100s[0] = temp_100s[0]; }
								 	lcd_line1[0] = 'D';	  }
							else { lcd_line1[0] = 'T';
								flagi2 &= ~COLUMN_ALARM_ENABLED_FLAG;
								if ((flagi3 & AUTO_PWM_STARTED_FLAG) != 0) {
								    flagi3 &= ~PWM_ENABLED_FLAG;
													   }
								flagi3 &= ~AUTO_PWM_STARTED_FLAG;
								virt_lcd_line2[32] = ' ';
								alarm_type &= ~COLUMN_ALARM_TYPE;
							     }
												}
/*--------------------------------------------------------------------*/
    /* press KEY_4 - 2nd LCD line - head */
	  if (((soft_keys & SOFT_KEY_4_MASK) != 0) && ((soft_keys & SOFT_KEY_4_OLD_MASK) == 0)) { 
							flagi2 ^= HEAD_IS_DELTA_FLAG;
	    						if ((flagi2 & HEAD_IS_DELTA_FLAG) != 0) {
								if (flagi3 & TEMP_2_FILTER_ENABLED)
									{ temp_delta_base_100s[1] = temp_2_filtered_10sec_100s; }
								else	{ temp_delta_base_100s[1] = temp_100s[1]; }
	    							virt_lcd_line2[0] = 'D';	}
	    						else {  virt_lcd_line2[0] = 'T';
	    							flagi &= ~HEAD_ALARM_ENABLED_FLAG;
	    							alarm_type &= ~HEAD_ALARM_TYPE;
	    						     }
												}
/*--------------------------------------------------------------------*/
	  if ((soft_keys & SOFT_KEY_2_MASK) != 0) { if ((alarm_type & PREHEAT_COLUMN_ALARM_TYPE) != 0) { flagi3 |= PREHEAT_COLUMN_ALARM_CANCEL; }
						    alarm_type = 0;
						    if ((flagi2 & COLUMN_IS_DELTA_FLAG) != 0) {
							if ((flagi2 & COLUMN_ALARM_ENABLED_FLAG) != 0) {
							    lcd_line1[0] = 'A'; }
							else {
							    lcd_line1[0] = 'D'; }
												}
						    else {
							lcd_line1[0] = 'T';
							 }
						    if ((flagi2 & HEAD_IS_DELTA_FLAG) != 0) {
							if ((flagi & HEAD_ALARM_ENABLED_FLAG) != 0) {
							    virt_lcd_line2[0] = 'A'; 		}
							else {
							    virt_lcd_line2[0] = 'D'; 		}
											    }
						    else {
							virt_lcd_line2[0] = 'T';
							 }
							  }

/*--------------------------------------------------------------------*/

    #if (defined(__AVR_ATmega328P__) || defined(__AVR_ATmega168P__))
/* ------- encoder CW ------ */
	  if (((soft_keys2 & SOFT_ENCODER_PLUS_MASK) != 0) && ((soft_keys2 & SOFT_ENCODER_PLUS_OLD_MASK) == 0) && 
	      ((soft_keys2 & SOFT_ENCODER_MINUS_MASK) != 0) && ((soft_keys2 & SOFT_ENCODER_MINUS_OLD_MASK) != 0)) {
		    if (((flagi3 & DOWNCOUNT_TIMER_STARTED_FLAG) == 0) && 
			 (lcd_third_line_mode == 1)) {
			encoder_position++;
			if (encoder_position == TIME_TABLE_MAX) { encoder_position = 0; }
			/* time table look-up */
    #if defined(__AVR__)
			downcount_timer_hour = pgm_read_byte_near((PGM_P)&time_table[encoder_position][0]);
			downcount_timer_minute = pgm_read_byte_near((PGM_P)&time_table[encoder_position][1]);
			downcount_timer_second = pgm_read_byte_near((PGM_P)&time_table[encoder_position][2]);
    #endif
    #if defined(__ets__)
			downcount_timer_hour = time_table[encoder_position][0];
			downcount_timer_minute = time_table[encoder_position][1];
			downcount_timer_second = time_table[encoder_position][2];
    #endif

						     }
    #if defined PWM_TIMER
		    if (lcd_third_line_mode == 3) {
			pwm_output_idx++;
			if (pwm_output_idx == PWM_TABLE_MAX) { pwm_output_idx = 0; }
	#if defined(__AVR__)
			pwm_output = pgm_read_byte((PGM_P)&PWM_table[pwm_output_idx]);
        #endif
	#if defined(__ets__)
			pwm_output = PWM_table[pwm_output_idx];
        #endif
						  }
    #endif
														 }

/* ------- encoder CCW ------ */

	  if (((soft_keys2 & SOFT_ENCODER_PLUS_MASK) != 0) && ((soft_keys2 & SOFT_ENCODER_PLUS_OLD_MASK) == 0) && 
	      ((soft_keys2 & SOFT_ENCODER_MINUS_MASK) == 0) && ((soft_keys2 & SOFT_ENCODER_MINUS_OLD_MASK) == 0)) {
		    if (((flagi3 & DOWNCOUNT_TIMER_STARTED_FLAG) == 0) && 
			 (lcd_third_line_mode == 1)) {
			encoder_position--;
			if (encoder_position == 0xFF) { encoder_position = TIME_TABLE_MAX - 1; }
			/* time table look-up */
    #if defined(__AVR__)
			downcount_timer_hour = pgm_read_byte_near((PGM_P)&time_table[encoder_position][0]);
			downcount_timer_minute = pgm_read_byte_near((PGM_P)&time_table[encoder_position][1]);
			downcount_timer_second = pgm_read_byte_near((PGM_P)&time_table[encoder_position][2]);
    #endif
    #if defined(__ets__)
			downcount_timer_hour = time_table[encoder_position][0];
			downcount_timer_minute = time_table[encoder_position][1];
			downcount_timer_second = time_table[encoder_position][2];
    #endif
						     }
    #if defined PWM_TIMER
		    if (lcd_third_line_mode == 3) {
			pwm_output_idx--;
			if (pwm_output_idx == 0xFF) { pwm_output_idx = PWM_TABLE_MAX - 1; }
	#if defined(__AVR__)
			pwm_output = pgm_read_byte((PGM_P)&PWM_table[pwm_output_idx]);
        #endif
	#if defined(__ets__)
			pwm_output = PWM_table[pwm_output_idx];
        #endif
						  }
    #endif
														 }
    #endif

/*--------------------------------------------------------------------------------------*/
/* 	should NOT use eeprom_write, as it may take 2ms to complete... 		*/
/*	Switching LCD mode: 4 line / 2 line horizontal scroll / 2 line vertical scroll  */
/*--------------------------------------------------------------------------------------*/
//	  if (((soft_keys & SOFT_KEY_1_MASK) != 0) && 
//	      ((soft_keys2 & SOFT_KEY_1_OLD_MASK) == 0) && 
//	       (flagi & IN_CONFIG_FLAG) == 0)	    {
//					if((lcd_flagi & LCD_4LINE_FLAG) != 0) { lcd_flagi &= ~LCD_4LINE_FLAG;
//										  lcd_flagi &= ~LCD_OPERATION_MODE_FLAG;
//									      }
//					else if ((lcd_flagi & LCD_OPERATION_MODE_FLAG) == 0) {
//						lcd_flagi |= LCD_OPERATION_MODE_FLAG; 	     }
//						else {  lcd_flagi |= LCD_4LINE_FLAG; }
//					#if defined(__AVR__)
//					    eeprom_write_byte(&lcd_flags_in_eeprom, lcd_flagi);
//					#endif
//					#if defined(__ets__)
//					file_t config_file;
//					    config_file = fileOpen("lcd_flagi.bin", eFO_WriteOnly);
//					    fileWrite(config_file, &lcd_flagi, 1);
//					    fileClose(config_file);
//					#endif
//						    }
/*--------------------------------------------------------------------*/
/* "press and hold for key 3 - 1st lcd line - T column                */
/*--------------------------------------------------------------------*/
	  if (((soft_keys & SOFT_KEY_3_MASK) != 0) && 
	      ((soft_keys & SOFT_KEY_3_OLD_MASK) != 0) && 
	      ((soft_key_3_timer < 250))) { soft_key_3_timer++; }
	  if ((soft_keys & SOFT_KEY_3_MASK) == 0) { soft_key_3_timer = 0; }

/* enable ALARM on LONG press                                         */
	  if ((soft_key_3_timer > 200) && 
	     ((flagi2 & COLUMN_IS_DELTA_FLAG) != 0)) { flagi2 |= COLUMN_ALARM_ENABLED_FLAG; }
/*--------------------------------------------------------------------*/
/* "press and hold for key 4 - 2nd lcd line - T head                  */
/*--------------------------------------------------------------------*/
	  if (((soft_keys & SOFT_KEY_4_MASK) != 0) && 
	      ((soft_keys & SOFT_KEY_4_OLD_MASK) != 0) && 
	      ((soft_key_4_timer < 250))) { soft_key_4_timer++; }
	  if ((soft_keys & SOFT_KEY_4_MASK) == 0) { soft_key_4_timer = 0; }

/* enable ALARM on LONG press                                         */
	  if ((soft_key_4_timer > 200) && 
	     ((flagi2 & HEAD_IS_DELTA_FLAG) != 0)) { flagi |= HEAD_ALARM_ENABLED_FLAG; }
/* ------------------------------------------------------------------ */
/* "press and hold for key 6 - 4th lcd line */
/* - 4th line switch Tliquid / Liquid percentage (Akas lookup) ------ */
/* ------------------------------------------------------------------ */
	  if (((SOFT_KEY_6_MASK_VARIABLE & SOFT_KEY_6_MASK) != 0) && 
	      ((SOFT_KEY_6_OLD_MASK_VARIABLE & SOFT_KEY_6_OLD_MASK) != 0) && 
	      ((soft_key_6_timer < 250))) { soft_key_6_timer++; }
/*--------------------------------------------------------------------*/
/* falling edge of keypress */
	  if (((SOFT_KEY_6_MASK_VARIABLE & SOFT_KEY_6_MASK) == 0) && 
	      ((SOFT_KEY_6_OLD_MASK_VARIABLE & SOFT_KEY_6_OLD_MASK) != 0)) {
	      if (soft_key_6_timer > 200) {  /* long press */
							// ENABLE / DISABLE AUTO mode //
							if (((flagi3 & AUTO_PWM_STARTED_FLAG) == 0) && 
							    ((COLUMN_IS_DELTA_FLAG_VARIABLE & COLUMN_IS_DELTA_FLAG) != 0) && 
							    ((COLUMN_ALARM_ENABLED_FLAG_VARIABLE & COLUMN_ALARM_ENABLED_FLAG) == 0) && 
							    ( pwm_output > MIN_AUTO_PWM))
							    { flagi3 |= AUTO_PWM_STARTED_FLAG; }
							else
							    { 	flagi3 &= ~AUTO_PWM_STARTED_FLAG;
								flagi3 &= ~AUTO_PWM_DOWNCOUNT_TIMER_STARTED_FLAG;
//			#if defined(__AVR__)
								auto_pwm_downcount_timer_minute = 10; //pgm_read_byte_near((PGM_P)&time_table[encoder_position][1]);
								auto_pwm_downcount_timer_second = 0; //pgm_read_byte_near((PGM_P)&time_table[encoder_position][2]);
//			#endif
							     }

							// enabling AUTO
	    						if ((flagi3 & AUTO_PWM_STARTED_FLAG) != 0) {
	    						    virt_lcd_line2[32] = 'A';	           
	    						    flagi3 |= PWM_ENABLED_FLAG;
	    											   }
	    						// disabling AUTO
	    						else {  virt_lcd_line2[32] = ' ';
	    							flagi3 &= ~PWM_ENABLED_FLAG;
	    							alarm_type &= ~COLUMN_ALARM_TYPE;
	    						     }
					  }
				    else { /* short press */
							flagi2 ^= LIQUID_AS_PERCENT_FLAG;
							if ((flagi2 & LIQUID_AS_PERCENT_FLAG) != 0) {
								virt_lcd_line2[33] = '%';
								virt_lcd_line2[47] = '%';	    }
							else { virt_lcd_line2[33] = 'T';
							       virt_lcd_line2[47] = 'C'; }
					  }
									  } // falling edge
	/* reset key timer as key released */
	  if ((SOFT_KEY_6_MASK_VARIABLE & SOFT_KEY_6_MASK) == 0) { soft_key_6_timer = 0; }
/*--------------------------------------------------------------------*/
/* "press and hold for encoder key - 3rd lcd line */
/*--------------------------------------------------------------------*/
/* pressed for at least 2 samples */
	  if (((soft_keys3 & SOFT_ENCODER_SWITCH_MASK) != 0) && 
	      ((soft_keys3 & SOFT_ENCODER_SWITCH_OLD_MASK) != 0) && 
	      ((soft_encoder_switch_timer < 250))) { soft_encoder_switch_timer++; }
/*--------------------------------------------------------------------*/
/* falling edge of keypress */
	  if (((soft_keys3 & SOFT_ENCODER_SWITCH_MASK) == 0) && 
	      ((soft_keys3 & SOFT_ENCODER_SWITCH_OLD_MASK) != 0)) {
	      if (soft_encoder_switch_timer < 200) { /* short press */
		lcd_third_line_mode++;
    #if defined PWM_TIMER
		if (lcd_third_line_mode == 4) { lcd_third_line_mode = 0; }
    #else
		if (lcd_third_line_mode == 3) { lcd_third_line_mode = 0; }
    #endif
		soft_encoder_switch_timer = 0;
						   }
	      else {				    /* long press */
		    if (lcd_third_line_mode == 1) {
			switch (flagi3 & DOWNCOUNT_TIMER_STARTED_FLAG) {
			    case 0: 
					if  ((downcount_timer_second != 0) ||
					     (downcount_timer_minute != 0) ||
					     (downcount_timer_hour != 0))		{
						flagi3 |= DOWNCOUNT_TIMER_STARTED_FLAG; }
					break;

			    case DOWNCOUNT_TIMER_STARTED_FLAG:
					flagi3 &= ~DOWNCOUNT_TIMER_STARTED_FLAG;
    #if (defined(__AVR_ATmega328P__) || defined(__AVR_ATmega168P__))
					downcount_timer_hour = pgm_read_byte_near((PGM_P)&time_table[encoder_position][0]);
					downcount_timer_minute = pgm_read_byte_near((PGM_P)&time_table[encoder_position][1]);
					downcount_timer_second = pgm_read_byte_near((PGM_P)&time_table[encoder_position][2]);
    #endif
    #if defined(__ets__)
					downcount_timer_hour = time_table[encoder_position][0];
					downcount_timer_minute = time_table[encoder_position][1];
					downcount_timer_second = time_table[encoder_position][2];
    #endif
					break;
									}
					      }

		    if (lcd_third_line_mode == 3) {
			switch (flagi3 & PWM_ENABLED_FLAG)  {
			    case 0: 
					flagi3 |= PWM_ENABLED_FLAG; 
					break;
			    case PWM_ENABLED_FLAG:
					flagi3 &= ~PWM_ENABLED_FLAG;
					break;
							    }
						}
			soft_encoder_switch_timer = 0;
		    } /* / long press */
								  } /* falling edge of keypress */

/*--------------------------------------------------------------------*/
/* update OLD soft keys */
/*--------------------------------------------------------------------*/

	if ((soft_keys & SOFT_KEY_3_MASK) != 0) { soft_keys |= SOFT_KEY_3_OLD_MASK; }
	else					{ soft_keys &= ~SOFT_KEY_3_OLD_MASK; }
	if ((soft_keys & SOFT_KEY_4_MASK) != 0) { soft_keys |= SOFT_KEY_4_OLD_MASK; }
	else					{ soft_keys &= ~SOFT_KEY_4_OLD_MASK; }
	if ((soft_keys & SOFT_KEY_1_MASK) != 0) { soft_keys2 |= SOFT_KEY_1_OLD_MASK; }
	else					{ soft_keys2 &= ~SOFT_KEY_1_OLD_MASK; }
	if ((soft_keys & SOFT_KEY_2_MASK) != 0) { soft_keys2 |= SOFT_KEY_2_OLD_MASK; }
	else					{ soft_keys2 &= ~SOFT_KEY_2_OLD_MASK; }
    #if !defined PWM_TIMER
	if ((soft_keys & SOFT_KEY_5_MASK) != 0) { soft_keys2 |= SOFT_KEY_5_OLD_MASK; }
	else					{ soft_keys2 &= ~SOFT_KEY_5_OLD_MASK; }
    #endif
	if ((soft_keys & SOFT_KEY_6_MASK) != 0) { soft_keys2 |= SOFT_KEY_6_OLD_MASK; }
	else					{ soft_keys2 &= ~SOFT_KEY_6_OLD_MASK; }
	if ((soft_keys2 & SOFT_ENCODER_PLUS_MASK) != 0) { soft_keys2 |= SOFT_ENCODER_PLUS_OLD_MASK; }
	else						{ soft_keys2 &= ~SOFT_ENCODER_PLUS_OLD_MASK; }
	if ((soft_keys2 & SOFT_ENCODER_MINUS_MASK) != 0) { soft_keys2 |= SOFT_ENCODER_MINUS_OLD_MASK; }
	else						 { soft_keys2 &= ~SOFT_ENCODER_MINUS_OLD_MASK; }
	if ((soft_keys3 & SOFT_ENCODER_SWITCH_MASK) != 0) { soft_keys3 |= SOFT_ENCODER_SWITCH_OLD_MASK; }
	else						 { soft_keys3 &= ~SOFT_ENCODER_SWITCH_OLD_MASK; }

}
