#ifndef KEYBOARD_PROCESSING_H
#define KEYBOARD_PROCESSING_H

#include <stdint.h>

void keyboard_filter(void);

extern volatile uint8_t	key_1_filter;
extern volatile uint8_t	key_2_filter;
extern volatile uint8_t	key_3_filter;
extern volatile uint8_t	key_4_filter;
extern volatile uint8_t	key_5_filter;
extern volatile uint8_t	key_6_filter;
extern volatile uint8_t	encoder_plus_filter;
extern volatile uint8_t	encoder_minus_filter;
extern volatile uint8_t	encoder_switch_filter;
extern volatile uint8_t	encoder_position;

extern volatile uint8_t	soft_keys;
extern volatile uint8_t	soft_keys2;
extern volatile uint8_t	soft_keys3;
extern volatile uint8_t	soft_key_3_timer;
extern volatile uint8_t	soft_key_4_timer;
extern volatile uint8_t	soft_key_6_timer;
extern volatile uint8_t	soft_encoder_switch_timer;

extern 		uint8_t	ones_count8(uint8_t code, uint8_t bits);

extern volatile	uint8_t		flagi, flagi2, flagi3;
#if defined(__AVR__)
extern volatile	uint8_t lcd_flagi, lcd_third_line_mode;
#endif
#if defined(__ets__)
extern 		uint8_t lcd_flagi, lcd_third_line_mode;
#endif

#if defined DOWNCOUNT_TIMER
extern volatile	uint8_t 	downcount_timer_second;
extern volatile	uint8_t		downcount_timer_minute;
extern volatile	uint8_t		downcount_timer_hour;
#endif

#if defined PWM_TIMER
extern volatile	uint8_t 	pwm_timer;
extern volatile	uint8_t 	pwm_output_idx;
extern volatile	uint8_t 	pwm_output;
#endif

#if defined AUTO_PWM_DOWNCOUNT_TIMER
extern volatile	uint8_t		auto_pwm_downcount_timer_minute;
extern volatile	uint8_t		auto_pwm_downcount_timer_second;
#endif

extern uint16_t	temp_delta_base_100s[4];
extern uint16_t	temp_100s[4];
extern uint16_t	temp_1_filtered_10sec_100s;
extern uint16_t	temp_2_filtered_10sec_100s;

extern 	char	lcd_line1[17];
extern 	uint8_t	virt_lcd_line2[49];

extern uint8_t	alarm_type;

#if (defined(__AVR_ATmega328P__) || defined(__AVR_ATmega168P__))
extern    const uint16_t	tabela_akasa[18][2]		PROGMEM;
extern    const uint8_t		time_table[TIME_TABLE_MAX][3]	PROGMEM;
extern    const uint8_t		PWM_table[PWM_TABLE_MAX]	PROGMEM;
#endif

#if defined(__ets__)
extern    const uint16_t	tabela_akasa[18][2];
extern    const uint8_t		time_table[TIME_TABLE_MAX][3];
extern    const uint8_t		PWM_table[PWM_TABLE_MAX];
#endif

#if defined(__AVR__)
extern    const uint8_t		lcd_flags_in_eeprom;
#endif
#if defined(__ets__)
    #include <SmingCore/SmingCore.h>
//    #include <SmingCore/Digital.h>
    #include <SmingCore/FileSystem.h>
#endif

// - #if ndef
#endif
