/*-----------------------*/
/* Variables definitions */
/*-----------------------*/
#include "defines.h"
#define uchar uint8_t
#define MAIN_H

volatile	uint8_t		flagi, flagi2;
volatile	uint8_t		flagi3, flagi4;
#if defined(__AVR__)
volatile	uint8_t lcd_flagi, lcd_third_line_mode;
#endif
#if defined(__ets__)
		uint8_t lcd_flagi, lcd_third_line_mode;
#endif
volatile	uint8_t		config_mode;
volatile	uint8_t		u_time;
volatile	uint8_t		deciseconds;
volatile	uint8_t		error_code;

		uint8_t		STS_byte3;
		uint8_t		STS_byte2;
		uint8_t		STS_byte1;
#if defined(__ets__)
		boolean		STS_Ready;
		float		STS_Temperature;
		float		STS_temp;
#endif

#if defined(__AVR__)
volatile	uint8_t		buffer_tx[120];
#endif
#if defined(__ets__)
		uint8_t		buffer_tx[120];
#endif

volatile	uint8_t		tx_pointer;

#if defined INCLUDE_RTC
volatile	uint8_t 	second;
volatile	uint8_t		minute;
volatile	uint8_t		hour;
#endif

#if defined DOWNCOUNT_TIMER
volatile	uint8_t 	downcount_timer_second;
volatile	uint8_t		downcount_timer_minute;
volatile	uint8_t		downcount_timer_hour;
#endif

#define AUTO_PWM_DOWNCOUNT_TIMER_MINUTE_DEFAULT	5
#define AUTO_PWM_DOWNCOUNT_TIMER_SECOND_DEFAULT	0

#if defined AUTO_PWM_DOWNCOUNT_TIMER
volatile	uint8_t 	auto_pwm_downcount_timer_second;
volatile	uint8_t		auto_pwm_downcount_timer_minute;
#endif

#if defined PWM_TIMER
volatile	uint8_t 	pwm_timer;
volatile	uint8_t 	pwm_output_idx;
volatile	uint8_t 	pwm_output;

#endif

#if defined(__ets__)
    #include <Libraries/OneWire/OneWire.h>
    #include <Libraries/LiquidCrystal/LiquidCrystal_I2C.h>
    #if defined(NODEMCU_HARDWARE_TIMER)
	#include <SmingCore/HardwareTimer.h>
    #endif

    OneWire		OneWire_bus(OW_PIN);
#if (LCD_TYPE == 0) // I2C
    LiquidCrystal_I2C 	lcd(I2C_LCD_ADDR, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);
#endif
#if (LCD_TYPE == 1) // SR
    LiquidCrystal_SR    lcd(0,4,5); //data, clock, enable
#endif
    SoftI2cMaster	I2C_bus(I2C_SDA, I2C_SCL);

    #if !defined(NODEMCU_HARDWARE_TIMER)
	Timer		Timer_1;
    #else
	Hardware_Timer	Timer_1;
    #endif
	Timer		Timer_2;
	Timer		Timer_500ms;

    bool		state;
    WDTClass		watchdog;
    uint8_t		wait_key_release;

    bool		IP_connected;
    TcpClient*		last_TcpClient;
    uint8_t		tcp_activeClients;

		HttpServer server;

		BssList networks;
		String network, password;
		Timer connectionTimer;
		Timer serversTimer;
		Timer LEDTimer;

		bool	AP_started;

//		TcpServer tcpServer;
#include "main_tcp_server.h"
		TcpServer tcpServer(tcpServerClientConnected, tcpServerClientReceive, tcpServerClientComplete);
#endif

    uint8_t		alarm_type;
    uint8_t		buzzer_mask;

#if defined PANMUFINEK
char		lcd_line1[17] = "   Tpary=  0.00C";
#else
char		lcd_line1[17];
#endif

#if defined(__AVR__)
volatile	uint8_t		lcd_time[10] = "00:00:00,";
#endif
#if defined(__ets__)
		uint8_t		lcd_time[10] = "00:00:00,";
#endif

uint8_t		lcd_virt_line[17] = "                ";

uint8_t		virt_lcd_line2[49];

#if defined(__AVR__)
volatile	uint8_t		num_of_sensors;
#endif
#if defined(__ets__)
		uint8_t		num_of_sensors;
#endif

uint8_t		sensor_addreses[4][8] = { 0x28,0xAD,0x94,0xCC,0x00,0x00,0x00,0x8B,
					  0x28,0xBB,0xE4,0xCB,0x01,0x00,0x00,0x22,
					  0x28,0x82,0xAA,0x2D,0x05,0x00,0x00,0xCC,
					  0x28,0x57,0x20,0x2E,0x50,0x00,0x00,0x1D,
					  };

uint8_t		temperature_labels[4][8] = { "kolumny",
					     "glowicy",
					     "  Twody",
					     "Tcieczy" };

uint8_t		lcd_offset;
uint8_t		lcd_horiz_offset;

uint8_t		i, j, z;
uint8_t		scratchpad_table[4][9];
uint8_t		lcd_pointer;

uint8_t		temp_units[4];
uint16_t	temp_parts[4];
uint8_t		temp_sign[4];

uint16_t	temp_100s[4]; /* temperature as 1/100 degrees, for DELTA calculations  */

#if defined(__ets__) 		/* for generating WWW fast */
boolean		temp_100s_valid[4];

boolean		serving_www;
#endif
#if defined(__AVR__)
uint8_t		temp_100s_valid;
#endif

/* temporary storage */
uint8_t		temp_units_t;
uint16_t	temp_parts_t;
uint8_t		temp_sign_t;
uint16_t	temp_100s_t;
uint16_t	temp_percentage_100s_t;

/* preheat alarm calculations */
uint32_t	temp_100s_t2;
uint32_t	temp_100s_t2_max;
uint32_t	temp_100s_t2_min;
/* deltas */
uint8_t		temp_sign_d;
uint16_t	temp_100s_d;

uint16_t	temp_delta_base_100s[4] = { 0, 0, 0, 0 } ; /* temperature base for delta as 1/100 degrees */
uint16_t	temp_100s_delta[4] = { 0, 0, 0, 0 } ; /* temperature delta as 1/100 degrees */
#if defined(__AVR__)
uint8_t		temp_100s_delta_sign;
#endif
#if defined(__ets__)
bool		temp_100s_delta_sign[4];
#endif

uint16_t	temp_1_filter_10sec_100s[10];
uint8_t		temp_1_filter_10sec_pointer;
uint16_t	temp_1_filtered_10sec_100s;
uint32_t	temp_1_filtered_10sec_100s_32;

uint16_t	temp_2_filter_10sec_100s[10];
uint8_t		temp_2_filter_10sec_pointer;
uint16_t	temp_2_filtered_10sec_100s;
uint32_t	temp_2_filtered_10sec_100s_32;

volatile uint8_t	key_1_filter;
volatile uint8_t	key_2_filter;
volatile uint8_t	key_3_filter;
volatile uint8_t	key_4_filter;
volatile uint8_t	key_5_filter;
volatile uint8_t	key_6_filter;
volatile uint8_t	encoder_plus_filter;
volatile uint8_t	encoder_minus_filter;
volatile uint8_t	encoder_switch_filter;
volatile uint8_t	encoder_position;

volatile uint8_t	soft_keys;
volatile uint8_t	soft_keys2;
volatile uint8_t	soft_keys3;
volatile uint8_t	soft_key_3_timer;
volatile uint8_t	soft_key_4_timer;
volatile uint8_t	soft_key_6_timer;
volatile uint8_t	soft_encoder_switch_timer;

#if (defined(__AVR_ATmega328P__) || defined(__AVR_ATmega168P__) || defined(__AVR_ATmega88P__))
const char	Initial_text[]		PROGMEM = "\n\r\n\rWersja 3.3 2017-02-09 (Mega328P)\n\r(c) laurentp@wp.pl\n\r\n\r";
#endif
#if defined(__AVR_ATmega8__)
const char	Initial_text[]		PROGMEM = "\n\r\n\rWersja 1.9 2015-12-25 (Mega8)\n\r(c) laurentp@wp.pl\n\r\n\r";
#endif
#if defined(__ets__)
const char	Initial_text[]			= "\n\r\n\rWersja 3.3 2017-02-09 (ESP8266)\n\r(c) laurentp@wp.pl\n\r\n\r";
#endif

#if (defined(__AVR_ATmega328P__) || defined(__AVR_ATmega168P__))
    const uint16_t		tabela_akasa[18][2]		PROGMEM = { 10000,  000, 
									     9900,  100,
									     9800,  300, 
									     9700,  400, 
									     9600,  600, 
									     9500,  800,
									     9400, 1000,
									     9300, 1100,
									     9200, 1300,
									     9100, 1600,
									     9000, 1800,
									     8900, 2000,
									     8800, 2300,
									     8700, 2600,
									     8600, 2900,
									     8500, 3400,
									     8400, 4000,
									     8300, 4600 };

    const uint8_t		time_table[TIME_TABLE_MAX][3]	PROGMEM = { 0,  0, 15,
									    0,  0, 30,
									    0,  0, 45,
									    0,  1,  0,
									    0,  1, 30,
									    0,  2,  0,
									    0,  5,  0,
									    0, 10,  0,
									    0, 15,  0,
									    0, 20,  0,
									    0, 25,  0,
									    0, 30,  0,
									    0, 45,  0,
									    1,  0,  0,
									    1, 15,  0,
									    1, 30,  0,
									    1, 45,  0,
									    2,  0,  0 };

    const uint8_t		PWM_table[PWM_TABLE_MAX]	PROGMEM = {   0,
									      1,
									      2,
									      3,
									      4,
									      5,
									      6,
									      7,
									      8,
									      9,
									     10,
									     20,
									     30,
									     40,
									     50,
									     60,
									     70,
									     80,
									     90,
									    100 };
#endif

#if defined(__ets__)
    const uint16_t		tabela_akasa[18][2]			= { 10000,  000, 
									     9900,  100,
									     9800,  300, 
									     9700,  400, 
									     9600,  600, 
									     9500,  800,
									     9400, 1000,
									     9300, 1100,
									     9200, 1300,
									     9100, 1600,
									     9000, 1800,
									     8900, 2000,
									     8800, 2300,
									     8700, 2600,
									     8600, 2900,
									     8500, 3400,
									     8400, 4000,
									     8300, 4600 };

    const uint8_t		time_table[TIME_TABLE_MAX][3]		= { 0,  0, 15,
									    0,  0, 30,
									    0,  0, 45,
									    0,  1,  0,
									    0,  1, 30,
									    0,  2,  0,
									    0,  5,  0,
									    0, 10,  0,
									    0, 15,  0,
									    0, 20,  0,
									    0, 25,  0,
									    0, 30,  0,
									    0, 45,  0,
									    1,  0,  0,
									    1, 15,  0,
									    1, 30,  0,
									    1, 45,  0,
									    2,  0,  0 };

    const uint8_t		PWM_table[PWM_TABLE_MAX]		= {   0,
									      1,
									      2,
									      3,
									      4,
									      5,
									      6,
									      7,
									      8,
									      9,
									     10,
									     20,
									     30,
									     40,
									     50,
									     60,
									     70,
									     80,
									     90,
									    100 };
#endif

#if defined(__AVR__)
    /* built-in EEPROM */
    const uint8_t		lcd_flags_in_eeprom		EEMEM = LCD_4LINE_FLAG;
    const uint8_t		num_of_sensors_eeprom		EEMEM = 4 ;
    const uint8_t		sensor_addreses_eeprom[4][8]	EEMEM = { 0x28,0xAD,0x94,0xCC,0x00,0x00,0x00,0x8B,
									  0x28,0x82,0xAA,0x2D,0x05,0x00,0x00,0xCC,
									  0x28,0xBB,0xE4,0xCB,0x01,0x00,0x00,0x22,
									  0x28,0xC1,0xB2,0xCB,0x01,0x00,0x00,0x7C};
    #if defined PANMUFINEK
	const uint8_t	temperature_labels_eeprom[4][8] EEMEM = { "   pary",
								  "glowicy",
								  "  Twody",
								  "  Tkega" };
    #endif
    #if defined(PRODUCTION_BOARD) || defined(PRODUCTION_BOARD_BY_KRZYSKI)
	const uint8_t	temperature_labels_eeprom[4][8] EEMEM = { "kolumny",
								  "glowicy",
								  "  Twody",
								  "Tcieczy" };
    #endif
    #if defined(DEV_BOARD_NANO)
	const uint8_t	temperature_labels_eeprom[4][8] EEMEM = { "zewn.  ",
								  "wewn.  ",
								  "Tkuchni",
								  "-------" };
    #endif

/* /built-in EEPROM */
#endif

/*-----------------------*/
