/* -------------------------------------------- */
/* display "virtual" LCD, using scroll and	*/
/* horizontal scroll				*/
/* -------------------------------------------- */

#include "virtual_lcd.h"

#if defined(__AVR__)
void LCD_virt_display(void) {
#endif
#if defined(__ets__)
void LCD_virt_display(LiquidCrystal_I2C lcd) {
#endif
    uint8_t i, j;
		/* ONLY every 500ms/1s 	  */
		/* Virtual 4 line display */
	#if defined(__AVR__)
	    lcd_gotoxy(0,0);
	    lcd_puts(&lcd_line1);
	    lcd_gotoxy(0,1);
	#endif
	#if defined(__ets__)
	    lcd.setCursor(0,0);
	    lcd.print((char *)&lcd_line1);
	    lcd.setCursor(0,1);
	#endif
	    if ((lcd_flagi & LCD_4LINE_FLAG) == 0) { /* 2 lines display, scroll it */
		for (i = 0; i < 16; i++) {
		    if ((lcd_flagi & LCD_OPERATION_MODE_FLAG) != 0) {
		    /* horizontal scroll */
			j = (i + lcd_horiz_offset);
			if (j > 47) { j -= 48; }
								    }
		    else {    /* vertical scroll */
			j = (i + (16 * lcd_offset));
		         }
		#if defined(__AVR__)
		    lcd_putc(virt_lcd_line2[j]);
		#endif
		#if defined(__ets__)
		    lcd.send(virt_lcd_line2[j], DATA);
		#endif
					} /* for */
						   } /* 2 lines display */
	    else { /* 4 lines display */
		for (i = 1; i < 4; i++) {
		#if defined(__AVR__)
		    lcd_gotoxy(0,i);
		    j = virt_lcd_line2[16 * i];
		    virt_lcd_line2[16 * i] = 0;
		    lcd_puts(&virt_lcd_line2[16 * (i - 1)]);
		    virt_lcd_line2[16 * i] = j;
		#endif
		#if defined(__ets__)
		    lcd.setCursor(0,i);
		    j = virt_lcd_line2[16 * i];
		    virt_lcd_line2[16 * i] = 0;
		    lcd.print((char *)&virt_lcd_line2[16 * (i - 1)]);
		    virt_lcd_line2[16 * i] = j;
		#endif
					 }
		 } // 4 lines display
			} // LCD_virt_display

/* *************************************************************************/

void prepare_hex_byte_to_lcd1(uint8_t bajt)
{
	if (((bajt & 0xF0) >> 4) < 10) { 
	    lcd_line1[lcd_pointer++] = ((bajt & 0xF0) >> 4) + '0'; }
	else { lcd_line1[lcd_pointer++] = ((bajt & 0xF0) >> 4) + 'A' -10; }
	if ((bajt & 0x0F) < 10) { 
	    lcd_line1[lcd_pointer++] = (bajt & 0x0F) + '0'; }
	else { lcd_line1[lcd_pointer++] = (bajt & 0x0F) + 'A' -10; }
}

/* *************************************************************************/

void prepare_hex_byte_to_lcd2(int8_t bajt) {
	if (((bajt & 0xF0) >> 4) < 10) { 
	    virt_lcd_line2[lcd_pointer++] = ((bajt & 0xF0) >> 4) + '0'; }
	else { virt_lcd_line2[lcd_pointer++] = ((bajt & 0xF0) >> 4) + 'A' -10; }
	if ((bajt & 0x0F) < 10) { 
	    virt_lcd_line2[lcd_pointer++] = (bajt & 0x0F) + '0'; }
	else { virt_lcd_line2[lcd_pointer++] = (bajt & 0x0F) + 'A' -10; }
								}

/* *************************************************************************/
